it-swarm.com.de

Die Installation von Magento beschwert sich über fehlende InnoDB, wenn sie verfügbar ist

Während der Installation gibt Magento den folgenden Fehler aus:

Der Datenbankserver unterstützt die InnoDB-Speicher-Engine nicht.

Ich habe alle Abhängigkeiten für Magento behoben und mit MySQL mithilfe von SHOW ENGINES in der Befehlszeile überprüft, und InnoDB ist definitiv verfügbar (auch die Standardspeicher-Engine).

Dies ist kein Problem beim Zugriff auf die MySQL-Konfiguration, das andere Benutzer möglicherweise bei ihrer Installation gesehen haben.

Hinweis: Dies wird auf einem Mac Pro ausgeführt (mit einer einfachen Host-DNS-Umschreibung für den Domänennamen, für den ich entwickle).

41
Giles Williams

Zeile 59 der Datei app/code/core/Mage/Install/Model/Installer/Db/Mysql4.php

Ersetzen:

public function supportEngine()
{
    $variables  = $this->_getConnection()
        ->fetchPairs('SHOW VARIABLES');
    return (!isset($variables['have_innodb']) || $variables['have_innodb'] != 'YES') ? false : true;
}

mit diesem:

public function supportEngine()
{
    $variables  = $this->_getConnection()
        ->fetchPairs('SHOW ENGINES');
    return (isset($variables['InnoDB']) && $variables['InnoDB'] != 'NO');
}
131

Oder mache keinen Core-Hack! Sie sollten das Installer-Modell vor der Installation sanft überschreiben:

Fügen Sie dies in Ihren app/code/local/Company/InstallBugfix/etc/config.xml ein:

<?xml version="1.0"?>
<config>
    <modules>
        <Company_InstallBugfix>
            <version>0.1.0</version>
        </Company_InstallBugfix>
    </modules>
    <global>
        <models>
            <installbugfix>
                <class>Company_InstallBugfix_Model</class>
            </installbugfix>
            <install>
                <rewrite>
                    <installer_db_mysql4>Company_InstallBugfix_Model_Installer_Db_Mysql4</installer_db_mysql4>
                </rewrite>
            </install>
        </models>
    </global>
</config>

Und folgendes in app/code/local/Company/InstallBugfix/Model/Installer/Db/Mysql4.php:

<?php
class Company_InstallBugfix_Model_Installer_Db_Mysql4 extends Mage_Install_Model_Installer_Db_Mysql4
{
    /**
     * Check InnoDB support
     *
     * @return bool
     */
    public function supportEngine()
    {
        $supportsEngine = parent::supportEngine();
        if ($supportsEngine) {
            return true;
        }
        $variables = $this
                     ->_getConnection()
                     ->fetchPairs('SHOW ENGINES');
        return (isset($variables['InnoDB']) && $variables['InnoDB'] != 'NO');
    }
}

Und aktivieren Sie die Erweiterung. Der Vorteil ist, dass die alte Validierung immer noch korrekt ist, wenn die mysql-Version älter ist.

20
Rokko_11

ver 1.9.1.0 downloader.php

Setzen Sie dies für alle Benutzer ein, die den downloader.php verwenden, der derzeit im 1.9.1.0-Installationsprogramm enthalten ist.

Wenn Sie sich darüber freuen, dass Ihre MySQL-Datenbank InnoDB (Es ist die DEFAULT) in späteren Versionen unterstützt. Sie können die Datei sicher bearbeiten, um die Prüfung zu entfernen und den gesamten Download durchzuführen.

    /**
     * Check availabe InnoDB on database.
     *
     * @return Magento_Downloader_Validator
     */
    protected function _checkDbInnoDb()
    {
        if (!$this->_connection) {
            return $this;
        }
        $this->addMessage('Database server supports InnoDB storage engine');
        return $this;
    }
5
Luke

Fehler wurde in Magento CE 1.8 behoben. Verwenden Sie daher einfach die obigen Zeilen für CE\leq 1.7

0
Rokko_11